/*
 * Copyright (c) 2005-2007 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.editors.reflective;

import fr.obeo.acceleo.gen.template.scripts.SpecificScript;

/**
 * An acceleo generator provider.
 * 
 * @author www.obeo.fr
 * 
 */
public interface IGeneratorProvider {

	/**
	 * Gets the generator.
	 * 
	 * @return the generator
	 */
	public SpecificScript getGenerator();

}
