/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ObjectFlowState;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Event;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.foundation.core.BehavioralFeature;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.Parameter;
import fr.obeo.acceleo.uml13.foundation.data_types.Expression;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Parameter</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getDefaultValue <em>Default Value</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getKind <em>Kind</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getBehavioralFeature <em>Behavioral Feature</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getType <em>Type</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getEvent <em>Event</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.impl.ParameterImpl#getState <em>State</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ParameterImpl extends ModelElementImpl implements Parameter {
	/**
	 * The cached value of the '{@link #getDefaultValue() <em>Default Value</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDefaultValue()
	 * @generated
	 * @ordered
	 */
	protected Expression defaultValue = null;

	/**
	 * The default value of the '{@link #getKind() <em>Kind</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getKind()
	 * @generated
	 * @ordered
	 */
	protected static final String KIND_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getKind() <em>Kind</em>}' attribute.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getKind()
	 * @generated
	 * @ordered
	 */
	protected String kind = KIND_EDEFAULT;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected Classifier type = null;

	/**
	 * The cached value of the '{@link #getState() <em>State</em>}' reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getState()
	 * @generated
	 * @ordered
	 */
	protected EList state = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ParameterImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getParameter();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Expression getDefaultValue() {
		return defaultValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDefaultValue(Expression newDefaultValue, NotificationChain msgs) {
		Expression oldDefaultValue = defaultValue;
		defaultValue = newDefaultValue;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__DEFAULT_VALUE, oldDefaultValue, newDefaultValue);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDefaultValue(Expression newDefaultValue) {
		if (newDefaultValue != defaultValue) {
			NotificationChain msgs = null;
			if (defaultValue != null)
				msgs = ((InternalEObject) defaultValue).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.PARAMETER__DEFAULT_VALUE, null, msgs);
			if (newDefaultValue != null)
				msgs = ((InternalEObject) newDefaultValue).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.PARAMETER__DEFAULT_VALUE, null, msgs);
			msgs = basicSetDefaultValue(newDefaultValue, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__DEFAULT_VALUE, newDefaultValue, newDefaultValue));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getKind() {
		return kind;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setKind(String newKind) {
		String oldKind = kind;
		kind = newKind;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__KIND, oldKind, kind));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public BehavioralFeature getBehavioralFeature() {
		if (eContainerFeatureID != CorePackage.PARAMETER__BEHAVIORAL_FEATURE)
			return null;
		return (BehavioralFeature) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setBehavioralFeature(BehavioralFeature newBehavioralFeature) {
		if (newBehavioralFeature != eContainer || (eContainerFeatureID != CorePackage.PARAMETER__BEHAVIORAL_FEATURE && newBehavioralFeature != null)) {
			if (EcoreUtil.isAncestor(this, newBehavioralFeature))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newBehavioralFeature != null)
				msgs = ((InternalEObject) newBehavioralFeature).eInverseAdd(this, CorePackage.BEHAVIORAL_FEATURE__PARAMETER, BehavioralFeature.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newBehavioralFeature, CorePackage.PARAMETER__BEHAVIORAL_FEATURE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__BEHAVIORAL_FEATURE, newBehavioralFeature, newBehavioralFeature));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier getType() {
		if (type != null && type.eIsProxy()) {
			Classifier oldType = type;
			type = (Classifier) eResolveProxy((InternalEObject) type);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.PARAMETER__TYPE, oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setType(Classifier newType) {
		Classifier oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Event getEvent() {
		if (eContainerFeatureID != CorePackage.PARAMETER__EVENT)
			return null;
		return (Event) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setEvent(Event newEvent) {
		if (newEvent != eContainer || (eContainerFeatureID != CorePackage.PARAMETER__EVENT && newEvent != null)) {
			if (EcoreUtil.isAncestor(this, newEvent))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newEvent != null)
				msgs = ((InternalEObject) newEvent).eInverseAdd(this, State_machinesPackage.EVENT__PARAMETER, Event.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newEvent, CorePackage.PARAMETER__EVENT, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.PARAMETER__EVENT, newEvent, newEvent));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getState() {
		if (state == null) {
			state = new EObjectWithInverseResolvingEList.ManyInverse(ObjectFlowState.class, this, CorePackage.PARAMETER__STATE, Activity_graphsPackage.OBJECT_FLOW_STATE__PARAMETER);
		}
		return state;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.PARAMETER__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.PARAMETER__NAMESPACE, msgs);
			case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CorePackage.PARAMETER__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CorePackage.PARAMETER__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.PARAMETER__BEHAVIORAL_FEATURE, msgs);
			case CorePackage.PARAMETER__EVENT:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.PARAMETER__EVENT, msgs);
			case CorePackage.PARAMETER__STATE:
				return ((InternalEList) getState()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.PARAMETER__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.PARAMETER__NAMESPACE, msgs);
			case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__BINDING:
				return basicSetBinding(null, msgs);
			case CorePackage.PARAMETER__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CorePackage.PARAMETER__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.PARAMETER__DEFAULT_VALUE:
				return basicSetDefaultValue(null, msgs);
			case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
				return eBasicSetContainer(null, CorePackage.PARAMETER__BEHAVIORAL_FEATURE, msgs);
			case CorePackage.PARAMETER__EVENT:
				return eBasicSetContainer(null, CorePackage.PARAMETER__EVENT, msgs);
			case CorePackage.PARAMETER__STATE:
				return ((InternalEList) getState()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.PARAMETER__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
				return eContainer.eInverseRemove(this, CorePackage.BEHAVIORAL_FEATURE__PARAMETER, BehavioralFeature.class, msgs);
			case CorePackage.PARAMETER__EVENT:
				return eContainer.eInverseRemove(this, State_machinesPackage.EVENT__PARAMETER, Event.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.PARAMETER__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.PARAMETER__NAME:
			return getName();
		case CorePackage.PARAMETER__VISIBILITY:
			return getVisibility();
		case CorePackage.PARAMETER__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.PARAMETER__NAMESPACE:
			return getNamespace();
		case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.PARAMETER__CONSTRAINT:
			return getConstraint();
		case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.PARAMETER__PRESENTATION:
			return getPresentation();
		case CorePackage.PARAMETER__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.PARAMETER__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CorePackage.PARAMETER__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CorePackage.PARAMETER__COMMENT:
			return getComment();
		case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CorePackage.PARAMETER__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CorePackage.PARAMETER__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.PARAMETER__BEHAVIOR:
			return getBehavior();
		case CorePackage.PARAMETER__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.PARAMETER__COLLABORATION:
			return getCollaboration();
		case CorePackage.PARAMETER__PARTITION:
			return getPartition();
		case CorePackage.PARAMETER__DEFAULT_VALUE:
			return getDefaultValue();
		case CorePackage.PARAMETER__KIND:
			return getKind();
		case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
			return getBehavioralFeature();
		case CorePackage.PARAMETER__TYPE:
			if (resolve)
				return getType();
			return basicGetType();
		case CorePackage.PARAMETER__EVENT:
			return getEvent();
		case CorePackage.PARAMETER__STATE:
			return getState();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.PARAMETER__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__NAME:
			setName((String) newValue);
			return;
		case CorePackage.PARAMETER__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CorePackage.PARAMETER__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.PARAMETER__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__BINDING:
			setBinding((Binding) newValue);
			return;
		case CorePackage.PARAMETER__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CorePackage.PARAMETER__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.PARAMETER__DEFAULT_VALUE:
			setDefaultValue((Expression) newValue);
			return;
		case CorePackage.PARAMETER__KIND:
			setKind((String) newValue);
			return;
		case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
			setBehavioralFeature((BehavioralFeature) newValue);
			return;
		case CorePackage.PARAMETER__TYPE:
			setType((Classifier) newValue);
			return;
		case CorePackage.PARAMETER__EVENT:
			setEvent((Event) newValue);
			return;
		case CorePackage.PARAMETER__STATE:
			getState().clear();
			getState().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.PARAMETER__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.PARAMETER__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.PARAMETER__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.PARAMETER__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.PARAMETER__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.PARAMETER__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.PARAMETER__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.PARAMETER__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.PARAMETER__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CorePackage.PARAMETER__BINDING:
			setBinding((Binding) null);
			return;
		case CorePackage.PARAMETER__COMMENT:
			getComment().clear();
			return;
		case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CorePackage.PARAMETER__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CorePackage.PARAMETER__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.PARAMETER__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.PARAMETER__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.PARAMETER__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.PARAMETER__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.PARAMETER__DEFAULT_VALUE:
			setDefaultValue((Expression) null);
			return;
		case CorePackage.PARAMETER__KIND:
			setKind(KIND_EDEFAULT);
			return;
		case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
			setBehavioralFeature((BehavioralFeature) null);
			return;
		case CorePackage.PARAMETER__TYPE:
			setType((Classifier) null);
			return;
		case CorePackage.PARAMETER__EVENT:
			setEvent((Event) null);
			return;
		case CorePackage.PARAMETER__STATE:
			getState().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.PARAMETER__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.PARAMETER__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.PARAMETER__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CorePackage.PARAMETER__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.PARAMETER__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.PARAMETER__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.PARAMETER__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.PARAMETER__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.PARAMETER__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.PARAMETER__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.PARAMETER__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CorePackage.PARAMETER__BINDING:
			return binding != null;
		case CorePackage.PARAMETER__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.PARAMETER__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.PARAMETER__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CorePackage.PARAMETER__STEREOTYPE:
			return stereotype != null;
		case CorePackage.PARAMETER__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.PARAMETER__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.PARAMETER__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.PARAMETER__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.PARAMETER__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.PARAMETER__DEFAULT_VALUE:
			return defaultValue != null;
		case CorePackage.PARAMETER__KIND:
			return KIND_EDEFAULT == null ? kind != null : !KIND_EDEFAULT.equals(kind);
		case CorePackage.PARAMETER__BEHAVIORAL_FEATURE:
			return getBehavioralFeature() != null;
		case CorePackage.PARAMETER__TYPE:
			return type != null;
		case CorePackage.PARAMETER__EVENT:
			return getEvent() != null;
		case CorePackage.PARAMETER__STATE:
			return state != null && !state.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (kind: "); //$NON-NLS-1$
		result.append(kind);
		result.append(')');
		return result.toString();
	}

} // ParameterImpl
