/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Link;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml14.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '<em><b>Link End</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkEndImpl#getInstance <em>Instance</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkEndImpl#getLink <em>Link</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkEndImpl#getAssociationEnd <em>Association End</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.LinkEndImpl#getQualifiedValue <em>Qualified Value</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class LinkEndImpl extends ModelElementImpl implements LinkEnd {
	/**
	 * The cached value of the '{@link #getInstance() <em>Instance</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInstance()
	 * @generated
	 * @ordered
	 */
	protected Instance instance = null;

	/**
	 * The cached value of the '{@link #getAssociationEnd() <em>Association End</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAssociationEnd()
	 * @generated
	 * @ordered
	 */
	protected AssociationEnd associationEnd = null;

	/**
	 * The cached value of the '{@link #getQualifiedValue() <em>Qualified Value</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getQualifiedValue()
	 * @generated
	 * @ordered
	 */
	protected EList qualifiedValue = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected LinkEndImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getLinkEnd();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getInstance() {
		if (instance != null && instance.eIsProxy()) {
			Instance oldInstance = instance;
			instance = (Instance) eResolveProxy((InternalEObject) instance);
			if (instance != oldInstance) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.LINK_END__INSTANCE, oldInstance, instance));
			}
		}
		return instance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance basicGetInstance() {
		return instance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetInstance(Instance newInstance, NotificationChain msgs) {
		Instance oldInstance = instance;
		instance = newInstance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK_END__INSTANCE, oldInstance, newInstance);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setInstance(Instance newInstance) {
		if (newInstance != instance) {
			NotificationChain msgs = null;
			if (instance != null)
				msgs = ((InternalEObject) instance).eInverseRemove(this, Common_behaviorPackage.INSTANCE__LINK_END, Instance.class, msgs);
			if (newInstance != null)
				msgs = ((InternalEObject) newInstance).eInverseAdd(this, Common_behaviorPackage.INSTANCE__LINK_END, Instance.class, msgs);
			msgs = basicSetInstance(newInstance, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK_END__INSTANCE, newInstance, newInstance));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Link getLink() {
		if (eContainerFeatureID != Common_behaviorPackage.LINK_END__LINK)
			return null;
		return (Link) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setLink(Link newLink) {
		if (newLink != eContainer || (eContainerFeatureID != Common_behaviorPackage.LINK_END__LINK && newLink != null)) {
			if (EcoreUtil.isAncestor(this, newLink))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newLink != null)
				msgs = ((InternalEObject) newLink).eInverseAdd(this, Common_behaviorPackage.LINK__CONNECTION, Link.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newLink, Common_behaviorPackage.LINK_END__LINK, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK_END__LINK, newLink, newLink));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd getAssociationEnd() {
		if (associationEnd != null && associationEnd.eIsProxy()) {
			AssociationEnd oldAssociationEnd = associationEnd;
			associationEnd = (AssociationEnd) eResolveProxy((InternalEObject) associationEnd);
			if (associationEnd != oldAssociationEnd) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.LINK_END__ASSOCIATION_END, oldAssociationEnd, associationEnd));
			}
		}
		return associationEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public AssociationEnd basicGetAssociationEnd() {
		return associationEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetAssociationEnd(AssociationEnd newAssociationEnd, NotificationChain msgs) {
		AssociationEnd oldAssociationEnd = associationEnd;
		associationEnd = newAssociationEnd;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK_END__ASSOCIATION_END, oldAssociationEnd, newAssociationEnd);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAssociationEnd(AssociationEnd newAssociationEnd) {
		if (newAssociationEnd != associationEnd) {
			NotificationChain msgs = null;
			if (associationEnd != null)
				msgs = ((InternalEObject) associationEnd).eInverseRemove(this, CorePackage.ASSOCIATION_END__LINK_END, AssociationEnd.class, msgs);
			if (newAssociationEnd != null)
				msgs = ((InternalEObject) newAssociationEnd).eInverseAdd(this, CorePackage.ASSOCIATION_END__LINK_END, AssociationEnd.class, msgs);
			msgs = basicSetAssociationEnd(newAssociationEnd, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.LINK_END__ASSOCIATION_END, newAssociationEnd, newAssociationEnd));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getQualifiedValue() {
		if (qualifiedValue == null) {
			qualifiedValue = new EObjectContainmentWithInverseEList(AttributeLink.class, this, Common_behaviorPackage.LINK_END__QUALIFIED_VALUE, Common_behaviorPackage.ATTRIBUTE_LINK__LINK_END);
		}
		return qualifiedValue;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.LINK_END__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK_END__NAMESPACE, msgs);
			case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.LINK_END__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__INSTANCE:
				if (instance != null)
					msgs = ((InternalEObject) instance).eInverseRemove(this, Common_behaviorPackage.INSTANCE__LINK_END, Instance.class, msgs);
				return basicSetInstance((Instance) otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__LINK:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.LINK_END__LINK, msgs);
			case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
				if (associationEnd != null)
					msgs = ((InternalEObject) associationEnd).eInverseRemove(this, CorePackage.ASSOCIATION_END__LINK_END, AssociationEnd.class, msgs);
				return basicSetAssociationEnd((AssociationEnd) otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
				return ((InternalEList) getQualifiedValue()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.LINK_END__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK_END__NAMESPACE, msgs);
			case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.LINK_END__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.LINK_END__INSTANCE:
				return basicSetInstance(null, msgs);
			case Common_behaviorPackage.LINK_END__LINK:
				return eBasicSetContainer(null, Common_behaviorPackage.LINK_END__LINK, msgs);
			case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
				return basicSetAssociationEnd(null, msgs);
			case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
				return ((InternalEList) getQualifiedValue()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.LINK_END__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case Common_behaviorPackage.LINK_END__LINK:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.LINK__CONNECTION, Link.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK_END__NAME:
			return getName();
		case Common_behaviorPackage.LINK_END__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.LINK_END__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.LINK_END__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.LINK_END__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.LINK_END__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.LINK_END__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Common_behaviorPackage.LINK_END__COMMENT:
			return getComment();
		case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Common_behaviorPackage.LINK_END__STEREOTYPE:
			return getStereotype();
		case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
			return getReferenceTag();
		case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Common_behaviorPackage.LINK_END__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.LINK_END__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Common_behaviorPackage.LINK_END__PARTITION:
			return getPartition();
		case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.LINK_END__INSTANCE:
			if (resolve)
				return getInstance();
			return basicGetInstance();
		case Common_behaviorPackage.LINK_END__LINK:
			return getLink();
		case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
			if (resolve)
				return getAssociationEnd();
			return basicGetAssociationEnd();
		case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
			return getQualifiedValue();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK_END__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.LINK_END__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Common_behaviorPackage.LINK_END__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.LINK_END__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Common_behaviorPackage.LINK_END__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.LINK_END__INSTANCE:
			setInstance((Instance) newValue);
			return;
		case Common_behaviorPackage.LINK_END__LINK:
			setLink((Link) newValue);
			return;
		case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
			setAssociationEnd((AssociationEnd) newValue);
			return;
		case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
			getQualifiedValue().clear();
			getQualifiedValue().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK_END__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK_END__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK_END__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.LINK_END__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.LINK_END__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.LINK_END__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.LINK_END__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Common_behaviorPackage.LINK_END__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Common_behaviorPackage.LINK_END__STEREOTYPE:
			getStereotype().clear();
			return;
		case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Common_behaviorPackage.LINK_END__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.LINK_END__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Common_behaviorPackage.LINK_END__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.LINK_END__INSTANCE:
			setInstance((Instance) null);
			return;
		case Common_behaviorPackage.LINK_END__LINK:
			setLink((Link) null);
			return;
		case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
			setAssociationEnd((AssociationEnd) null);
			return;
		case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
			getQualifiedValue().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.LINK_END__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.LINK_END__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Common_behaviorPackage.LINK_END__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.LINK_END__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.LINK_END__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.LINK_END__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.LINK_END__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.LINK_END__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.LINK_END__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.LINK_END__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.LINK_END__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Common_behaviorPackage.LINK_END__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.LINK_END__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.LINK_END__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.LINK_END__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Common_behaviorPackage.LINK_END__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Common_behaviorPackage.LINK_END__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.LINK_END__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Common_behaviorPackage.LINK_END__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Common_behaviorPackage.LINK_END__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.LINK_END__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.LINK_END__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.LINK_END__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Common_behaviorPackage.LINK_END__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.LINK_END__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.LINK_END__INSTANCE:
			return instance != null;
		case Common_behaviorPackage.LINK_END__LINK:
			return getLink() != null;
		case Common_behaviorPackage.LINK_END__ASSOCIATION_END:
			return associationEnd != null;
		case Common_behaviorPackage.LINK_END__QUALIFIED_VALUE:
			return qualifiedValue != null && !qualifiedValue.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // LinkEndImpl
